unit GetObjectImpl;

interface

function GetObject(DisplayName: string): IUnknown;

implementation

uses Windows, ActiveX, ComObj;

function GetObject(DisplayName: string): IUnknown;
var
  BindCtx: IBindCtx;
  Moniker: IMoniker;
  chEaten: Integer;
  PDisplayName: PWideChar;
  Unk: IUnknown;
begin
  OleCheck(CreateBindCtx(0, BindCtx));
  PDisplayName := StringToOleStr(DisplayName);
  try
    OleCheck(MkParseDisplayName(BindCtx, PDisplayName, chEaten, Moniker));
  finally
    SysFreeString(PDisplayName);
  end;

  OleCheck(Moniker.BindToObject(BindCtx, nil, IUnknown, Unk));

  Result := Unk;
end;

end.
