unit AspectTestImpl;

{$WARN SYMBOL_PLATFORM OFF}

interface

uses
  Windows, ActiveX, Classes, ComObj, AOPTypeLib_TLB, AspectTest_TLB, StdVcl;

type
  TTest = class(TTypedComObject, IAspect)
  protected
    function PreProcess(const pUnkDelegatee: IUnknown;
      const strMethodName: WideString; nvtblSlot: Integer;
      argsIn: OleVariant): HResult; stdcall;
    function PostProcess(hrOriginal: HResult; const pUnkDelegatee: IUnknown;
      const strMethodName: WideString; nvtblSlot: Integer;
      argsOut: OleVariant): HResult; stdcall;
  end;

implementation

uses ComServ, SysUtils, Variants, IdGlobal; { TODO : Pour DebugOutput }

function TTest.PreProcess(const pUnkDelegatee: IUnknown;
  const strMethodName: WideString; nvtblSlot: Integer;
  argsIn: OleVariant): HResult;
var
  I: Integer;
begin
  DebugOutput('TTest.PreProcess');

  for I := VarArrayLowBound(argsIn, 1) to VarArrayHighBound(argsIn, 1) do
    DebugOutput(Format('Arg %d : ' , [I]) + VarAsType(argsIn[I], varString));

  Result := S_OK;
end;

function TTest.PostProcess(hrOriginal: HResult;
  const pUnkDelegatee: IUnknown; const strMethodName: WideString;
  nvtblSlot: Integer; argsOut: OleVariant): HResult;
begin
  DebugOutput('TTest.PostProcess');

  Result := S_OK;
end;

initialization
  TTypedComObjectFactory.Create(ComServer, TTest, Class_Test,
    ciMultiInstance, tmApartment);
end.
